#ifndef _UFT4_APIDATASTRUCT_H_
#define _UFT4_APIDATASTRUCT_H_

#include "os_common.h"
#include "uft4_UserApiDataType.h"


typedef enum tagExchange_Type
{
	EXCHANGE_CFFEX = 0,	//н
	EXCHANGE_SHFE,		//1
	EXCHANGE_DCE,		//2
	EXCHANGE_SSEOPT,	//3֤Ȩ
	EXCHANGE_CZCE,		//4
	EXCHANGE_SZSE,		//5֤ȯ
	EXCHANGE_SSE,		//6Ϻ֤ȯ
	EXCHANGE_UNKNOWN,
}E_EXCHANGE_TYPE;

typedef struct tagUftFtdcInputOrderField
{
	///
	T_UFT_FtdcOrderSysIDType	OrderSysID;
	///Ա
	T_UFT_FtdcParticipantIDType	ParticipantID;
	///ͻ
	T_UFT_FtdcClientIDType	ClientID;
	///û
	T_UFT_FtdcUserIDType	UserID;
	///Լ
	T_UFT_FtdcInstrumentIDType	InstrumentID;
	///۸
	T_UFT_FtdcOrderPriceTypeType	OrderPriceType;
	///
	T_UFT_FtdcDirectionType	Direction;
	///Ͽƽ־
	T_UFT_FtdcCombOffsetFlagType	CombOffsetFlag;
	///Ͷױ־
	T_UFT_FtdcCombHedgeFlagType	CombHedgeFlag;
	///۸
	T_UFT_FtdcPriceType	LimitPrice;
	///
	T_UFT_FtdcVolumeType	VolumeTotalOriginal;
	///Ч
	T_UFT_FtdcTimeConditionType	TimeCondition;
	///GTD
	T_UFT_FtdcDateType	GTDDate;
	///ɽ
	T_UFT_FtdcVolumeConditionType	VolumeCondition;
	///Сɽ
	T_UFT_FtdcVolumeType	MinVolume;
	///
	T_UFT_FtdcContingentConditionType	ContingentCondition;
	///ֹ
	T_UFT_FtdcPriceType	StopPrice;
	///ǿƽԭ
	T_UFT_FtdcForceCloseReasonType	ForceCloseReason;
	///ر
	T_UFT_FtdcOrderLocalIDType	OrderLocalID;
	///Զ־
	T_UFT_FtdcBoolType	IsAutoSuspend;
	///ҵԪ
	T_UFT_FtdcBusinessUnitType	BusinessUnit;

}CUftFtdcInputOrderField;




// ͻֱֲ
typedef struct tagUftQryInvestorPositionField
{
	char		futu_code[7];		//	Լ	HsFuturesCode;ͨCFutuCode.Getȡ
	char		entrust_bs;			//		HsType0򣻡1
	int32_t		OldEnableAmount;	//	ϲֿ	HsQuantity
	int32_t		OldCurrentAmount;	//	ϲֲֳ	HsQuantity
	int32_t		TodayEnableAmount;//	տ	HsQuantity
	int32_t		TodayCurrentAmount;//	ճֲ	HsQuantity
	T_UFT_FtdcMoneyType	OldOpenBalance;	//	ϲֲֳֳɽ	HsAmount
	T_UFT_FtdcMoneyType	TodayOpenBalance;	//	ֲֳֳɽ	HsAmount
	T_UFT_FtdcMoneyType	HoldMargin;		//	ֱֲ֤	HsAmount
} QryInvestorPositionField;

// ¼
typedef struct tagUftReqOrderInsertField
{
	CUftFtdcInputOrderField	Order;
	int64_t						OrderRef;		//ʶ
	uint8_t                     MaginCheck;//ǷдŻݡ0ǷŻݣ1
} CUftReqOrderInsertField;


//̨Ӧ
typedef struct tagUftAnsOrderInsertField
{
	int64_t						OrderRef;		//ʶ
	uint32_t					OrderIndex;		//
	uint32_t					ProcessTime;	// ίдʱ
	uint32_t					TotalTime;		// Ӧʱ
	uint32_t					ExchangeTime;	// ʱ
	uint32_t					SenderID;
	uint32_t					LocalTimeDelay; //ʱ
	char                        StockCode[8];
	char						Direction;
	char						EntrustType;
	double						Price;
	int32_t						Amount;
} CUftAnsOrderInsertField;

//Ӧ
typedef struct tagUftRspnOrderInsertField
{
	int64_t						OrderRef;		//ʶ
	uint32_t					OrderIndex;     //ԭOrderIndex
	uint32_t					ProcessTime;	// ίдʱ
	uint32_t					TotalTime;		// Ӧʱ
	uint32_t					ExchangeTime;	// ʱ
	T_UFT_FtdcOrderSysIDType	OrderSysID;		//
	char						OrderStatus;	//״̬
	
} CUftRspnOrderInsertField;//API EXPOSURE




typedef struct tagUftAnsOrderActionField
{
	int64_t						OrderRef;		//ʶ
	uint32_t					OrderIndex;
	T_UFT_FtdcOrderSysIDType	OrderSysID;		//
	T_UFT_FtdcOrderLocalIDType	OrderLocalID;	//ر
	uint32_t					SenderID;
} CUftAnsOrderActionField;



//
typedef struct tagUftRspnOrderActionField
{
	T_UFT_FtdcOrderSysIDType		OrderSysID;		//
	T_UFT_FtdcOrderLocalIDType	OrderLocalID;	//ر
	int64_t						OrderRef;		//ʶ
	uint32_t					OrderIndex;	
} CUftRspnOrderActionField;



//ر
typedef struct tagUftRtnnOrderField
{
	int64_t						OrderRef;		//ʶ
	uint32_t					OrderIndex;     //
	uint32_t					ProcessTime;	// ίдʱ
	uint32_t					TotalTime;		// Ӧʱ
	uint32_t					ExchangeTime;	// ʱ
	T_UFT_FtdcOrderSysIDType	OrderSysID;		//
	T_UFT_FtdcVolumeType		VolumeTotal;	//ʣ
	T_UFT_FtdcOrderStatusType	OrderStatus;	//״̬
	char                        StockCode[8];
	char						EntrustType;
	char						Direction;
	double						Price;
	int32_t						Amount;
} CUftRtnnOrderField;



//ɽر
typedef struct tagUftRtnnTradeField
{
	T_UFT_FtdcPriceType				BusinessPrice;		// ɽ۸	HsFutuPrice
	int32_t							BusinessTime;		// ɽʱ	HsTime
	int32_t							BusinessAmount;		// ɽ	HsQuantity
	double							fare;				// 
	int64_t							OrderRef;			//ʶ
	uint32_t						OrderIndex;			// رʶ
	T_UFT_FtdcTradeIDType			BusinessId;		// ɽ	
	T_UFT_FtdcOrderSysIDType 		OrderSysID;			// ţchar[13], δ
	int8_t							session_id;		//ỰID
	char						    Direction;          //־
	char						    OffsetFlag;         //ƽ־
	char						    HedgeFlag;			//Ͷױ־
	int8_t            			    reserve[5];			//ռλ
	char							InstrumentID[17];     //Լ	
	char							StockCode[9];
} CUftRtnnTradeField;


//ʽѯӦ
typedef struct tagUftAnsQueryFundField
{
	T_UFT_FtdcMoneyType			EnabledBalance;	//ʽ
	T_UFT_FtdcMoneyType			Deposit;		//
	T_UFT_FtdcMoneyType			BeginBalance;	// ʼȨ
	T_UFT_FtdcMoneyType			Margin;			// ֤
	T_UFT_FtdcMoneyType			Profit;			//ƽӯ
	double						TotalFare;		//
	double						CurrBalance;	// ǰȨ
	double						floating_gain_loss; //ֲӯ
	double						FrozenBalance;	// ʽ
	uint32_t					SenderID;
	double						EnablePurQuota;	// ޹
} CUftAnsQueryFundField;


//ίвѯ
typedef struct tagUftReqQueryOrderField
{
	T_UFT_FtdcInstrumentIDType	InstrumentID;	//Լ룻InstrumentID[0]Ϊ'\0'ʾ
	int32_t						BeginTime;		//ίʼʱ䣻Ϊ0ʾ
	int32_t						EndTime;		//ίֹʱ䣻Ϊ0СBeginTimeʾ
	T_UFT_FtdcOrderSysIDType		OrderSysID;		//ţΪOrderSysID[0]Ϊ'\0'ʾ
	uint32_t					OrderIndex;		//رΪ0xFFFFFFFFʾ
	uint32_t					EntrustSenderID;//ͻ˱ţΪ0xFFFFFFFFʾ
	int64_t						OrderRef;		//ͻ˵ʶΪ-1ʾ
	uint32_t					Position;		//λָҳȡü¼ż֮ļ¼״0ʹӦеPositionֵ
	uint8_t						all_session_data;//Ϊ1ʾȡлỰ		

} CUftReqQueryOrderField;

//ίвѯӦ
typedef struct tagUftAnsQueryOrderField
{
	
	CUftFtdcInputOrderField	    Order;
	int64_t						OrderRef;		//ʶ
	char						MaginCheck;		// ǷдŻݡ0ǷŻݣ1
	int32_t						VolumeTotal;	//ίʣ
	char						OrderStatus;	// ״̬ѱɣɽϵ
	int8_t						session_id;		//ỰID
	int8_t            			reserve;		//ռλ
	int32_t						OrderTime;		// ίʱ
	uint32_t					SenderID;
	int32_t						ErrorID;
	uint32_t					OrderIndex;
	//֤ȯNST
	char						StockCode[8];   //Ʊ룬\0Կո
	char						Direction;      //־12
	char						EntrustType;    //ί'0'޼ίУ'1'ţ'2'ַʣת޼ۣ'3'мɽʣ೷'4'мȫɽ'5'м嵵ȫɽʣ೷
	char						CashMargin;		//ñʶ1=Cashͨף2=Open ȯ֣3=Close ȯƽ
	int8_t						TGWNo;			//رţ01~nָΧΪָر
	double						Price;			//ίм۸N13(4)
	double						Amount;			//ίN15(2)
	char						OrderSysID[17]; //
	char						ClOrdID[11];	//ص \0
} CUftAnsQueryOrderField;

//ɽѯ
typedef struct tagUftReqQueryTradeField
{
	T_UFT_FtdcInstrumentIDType	InstrumentID;	//Լ룻InstrumentID[0]Ϊ'\0'ʾ
	int32_t						BeginTime;		//ɽʼʱ䣻Ϊ0ʾ
	int32_t						EndTime;		//ɽֹʱ䣻Ϊ0СBeginTimeʾ
	T_UFT_FtdcOrderSysIDType		OrderSysID;		//ţΪOrderSysID[0]Ϊ'\0'ʾ
	uint32_t					OrderIndex;		//رΪ0xFFFFFFFFʾ
	int64_t						OrderRef;		//ͻ˵ʶΪ-1ʾ
	uint32_t					Position;		//λָҳȡü¼ż֮ļ¼״0ʹӦеPositionֵ
	uint8_t						all_session_data;//Ϊ1ʾȡлỰ		

} CUftReqQueryTradeField;

//ɽѯӦ
typedef struct tagUftAnsQueryTradeField
{
	T_UFT_FtdcPriceType				BusinessPrice;		// ɽ۸	HsFutuPrice
	int32_t							BusinessTime;		// ɽʱ	HsTime
	int32_t							BusinessAmount;		// ɽ	HsQuantity
	double							fare;				// 	
	int64_t							OrderRef;			//ʶ
	uint32_t						OrderIndex;			// رʶ
	T_UFT_FtdcTradeIDType			BusinessId;		// ɽ	HsChar32
	T_UFT_FtdcOrderSysIDType		OrderSysID;			// ţchar[16], δ
	int8_t							session_id;			//ỰID
	char							Direction;          //־
	char							OffsetFlag;         //ƽ־
	char					 		InstrumentID[17];	  //Լ	
	char							StockCode[8];       //Ʊ룬\0

} CUftAnsQueryTradeField;

//ֲֲѯ
typedef struct tagUftReqQueryPositionField
{
	T_UFT_FtdcInstrumentIDType	InstrumentID;	//Լ룻InstrumentID[0]Ϊ'\0'ʾ
} CUftReqQueryPositionField;

//ֲֲѯӦ
typedef struct tagUftAnsQueryPositionField
{
	//char		futu_code[7];		//	Լ	HsFuturesCode;ͨCFutuCode.Getȡ
	//char		futu_code[9];		//	
	char		futu_code[16];		//֧ͭȨԼȴ9λչ16ȫ
	char		entrust_bs;			//		HsType0򣻡1
	T_UFT_FtdcHedgeFlagType HedgeFlag;	//Ͷױ־	
//	char		reserve[7];
	char		reserve[6];
	int32_t		OldEnableAmount;	//	ϲֿ	HsQuantity
	int32_t		OldCurrentAmount;	//	ϲֲֳ	HsQuantity
	int32_t		TodayEnableAmount;//	տ	HsQuantity
	int32_t		TodayCurrentAmount;//	ճֲ	HsQuantity
	T_UFT_FtdcMoneyType	OldOpenBalance;	//	ϲֲֳֳɽ	HsAmount
	T_UFT_FtdcMoneyType	TodayOpenBalance;	//	ֲֳֳɽ	HsAmount
	T_UFT_FtdcMoneyType	HoldMargin;		//	ֱֲ֤	HsAmount
	char		StockCode[8];		//Ʊ룬\0Կո
	int64_t		EnableAmount;		//		HsQuantity 4
	int64_t		CurrentAmount;		//	ֲ	HsQuantity 4
} CUftAnsQueryPositionField;





// Ӧ280ֽ
typedef struct tagUftRspErrorField
{
	int32_t			ErrorNo;
	uint32_t		OrderIndex;			// رʶ
	int64_t			OrderRef;			//ʶ
	char			ErrorMsg[256];
	uint32_t		SendID;
	

} CUftRspErrorField;



//Լ״̬
typedef struct tagUftRtnInstrumentStatusField
{
	///
	T_UFT_FtdcSettlementGroupIDType	SettlementGroupID;
	///Լ
	T_UFT_FtdcInstrumentIDType	InstrumentID;
	///Լ״̬
	T_UFT_FtdcInstrumentStatusType	Status;
	///׽׶α
	T_UFT_FtdcTradingSegmentSNType	TradingSegmentSN;
	///뱾״̬ʱ
	T_UFT_FtdcTimeType	EnterTime;
	///뱾״̬ԭ
	T_UFT_FtdcInstStatusEnterReasonType	EnterReason;
	///뱾״̬

	//T_UFT_FtdcDateType	EnterDate;
    //֤ȯNST
	uint16_t					PlatformID;
	uint16_t					PlatformState;
}CUftRtnInstrumentStatusField;



typedef struct tagUftRspTest
{
	int32_t TimeDelay;
	
}CUftRspTest;

typedef struct tagUftRspUserLoginField
{													   
	T_UFT_ORDERREF_TYPE MaxOrderRef;
	T_UFT_TRADEDATE_TYPE TradeDate;
}CUftRspUserLoginField;

typedef struct tagUftRspInfoField
{
	///
	T_UFT_ErrorIDType	ErrorID;
	///Ϣ
	T_UFT_ErrorMsgType	ErrorMsg;
}CUftRspInfoField;

#endif
